(function () {
    "use strict";

    angular.module('core').controller('fluxoCaixaController', controller);
    controller.$inject = ['$scope', '$filter', '$timeout', '$q', 'toolsService', 'lookupService', 'fluxoCaixaService'];

    function controller($scope, $filter, $timeout, $q, toolsService, lookupService, fluxoCaixaService) {
        $scope.initializeLayout('Fluxo de Caixa');

        $scope.state = {
            data: [],
            carregando: false,
            filtro: {
                args: null,
                ativo: false
            }
        };

        $scope.auxiliar = {
            filial: {
                lookup: function (chaves) {
                    return $q.when(
                        lookupService
                            .getAllFilial({ chaves: chaves })
                            .then(function (response) {
                                if (response.Status < 0)
                                    $scope.tools.toastr.error(response.Message, "Serviço");
                                else
                                    return response.Data;
                            })
                    );
                }
            }
        };

        /* funções */
        $scope.initialize = function () {
            $scope.clearFilter();
        };

        $scope.getAll = function () {
            $scope.state.carregando = true;

            fluxoCaixaService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.data);
                        }
                        $scope.state.carregando = false;
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                    }
                );
        };

        $scope.refresh = function () {
            $scope.getAll();
            $scope.state.filtro.ativo = false;
        };

        $scope.clearFilter = function () {

            $scope.state.filtro.args = {
                filial: null,
                ano: (new Date).getFullYear()
            };

            $scope.refresh();
        };
        $scope.toggleFilter = function () {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };

        $scope.initialize();

    }

})();